package edu.berkeley.sbp;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.util.*;
import java.io.*;
import java.util.*;

/** thrown when the parser arrives at a state from which it is clear that no valid parse can result */
public class ParseFailed extends RuntimeException {
    private final Token.Location location;
    private final String message;
    public ParseFailed() { this("", null); }
    public ParseFailed(String message, Token.Location loc) { this.location = loc; this.message = message; }
    public Token.Location getLocation() { return location; }
    public String toString() { return message/* + (location==null ? "" : (" at " + location))*/; }
}
